/*
 * =======================================================================================
 *
 *      Filename:  numa_hwloc.h
 *
 *      Description:  Header File hwloc NUMA backend
 *
 *      Version:   4.3.4
 *      Released:  05.04.2019
 *
 *      Author:   Thomas Roehl (tr), thomas.roehl@googlemail.com
 *      Project:  likwid
 *
 *      Copyright (C) 2019 RRZE, University Erlangen-Nuremberg
 *
 *      This program is free software: you can redistribute it and/or modify it under
 *      the terms of the GNU General Public License as published by the Free Software
 *      Foundation, either version 3 of the License, or (at your option) any later
 *      version.
 *
 *      This program is distributed in the hope that it will be useful, but WITHOUT ANY
 *      WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 *      PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License along with
 *      this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * =======================================================================================
 */
#ifndef LIKWID_NUMA_HWLOC
#define LIKWID_NUMA_HWLOC

extern int hwloc_numa_init(void);
extern void hwloc_numa_membind(void* ptr, size_t size, int domainId);
extern void hwloc_numa_setInterleaved(int* processorList, int numberOfProcessors);

#endif
